/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the CxTemplate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplate{}

// CxTemplate struct for CxTemplate
type CxTemplate struct {
	Name *string `json:"name,omitempty"`
	HeaderImageUrls []CxTemplateHeaderImageUrlsInner `json:"header_image_urls,omitempty"`
	Description *string `json:"description,omitempty"`
	Languages []string `json:"languages,omitempty"`
	Integrations *CxTemplateIntegrations `json:"integrations,omitempty"`
	RequiredMessengers []string `json:"required_messengers,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Interactions []CxTemplateInteractionsInner `json:"interactions,omitempty"`
	Global *bool `json:"global,omitempty"`
	Formality *string `json:"formality,omitempty"`
	PreviewUrls []CxTemplatePreviewUrlsInner `json:"preview_urls,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	Id *string `json:"id,omitempty"`
	CreatedAt *time.Time `json:"created_at,omitempty"`
	UpdatedAt *time.Time `json:"updated_at,omitempty"`
	Status *string `json:"status,omitempty"`
}

// NewCxTemplate instantiates a new CxTemplate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplate() *CxTemplate {
	this := CxTemplate{}
	return &this
}

// NewCxTemplateWithDefaults instantiates a new CxTemplate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateWithDefaults() *CxTemplate {
	this := CxTemplate{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CxTemplate) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CxTemplate) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CxTemplate) SetName(v string) {
	o.Name = &v
}

// GetHeaderImageUrls returns the HeaderImageUrls field value if set, zero value otherwise.
func (o *CxTemplate) GetHeaderImageUrls() []CxTemplateHeaderImageUrlsInner {
	if o == nil || IsNil(o.HeaderImageUrls) {
		var ret []CxTemplateHeaderImageUrlsInner
		return ret
	}
	return o.HeaderImageUrls
}

// GetHeaderImageUrlsOk returns a tuple with the HeaderImageUrls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetHeaderImageUrlsOk() ([]CxTemplateHeaderImageUrlsInner, bool) {
	if o == nil || IsNil(o.HeaderImageUrls) {
		return nil, false
	}
	return o.HeaderImageUrls, true
}

// HasHeaderImageUrls returns a boolean if a field has been set.
func (o *CxTemplate) HasHeaderImageUrls() bool {
	if o != nil && !IsNil(o.HeaderImageUrls) {
		return true
	}

	return false
}

// SetHeaderImageUrls gets a reference to the given []CxTemplateHeaderImageUrlsInner and assigns it to the HeaderImageUrls field.
func (o *CxTemplate) SetHeaderImageUrls(v []CxTemplateHeaderImageUrlsInner) {
	o.HeaderImageUrls = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *CxTemplate) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *CxTemplate) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *CxTemplate) SetDescription(v string) {
	o.Description = &v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *CxTemplate) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *CxTemplate) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *CxTemplate) SetLanguages(v []string) {
	o.Languages = v
}

// GetIntegrations returns the Integrations field value if set, zero value otherwise.
func (o *CxTemplate) GetIntegrations() CxTemplateIntegrations {
	if o == nil || IsNil(o.Integrations) {
		var ret CxTemplateIntegrations
		return ret
	}
	return *o.Integrations
}

// GetIntegrationsOk returns a tuple with the Integrations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetIntegrationsOk() (*CxTemplateIntegrations, bool) {
	if o == nil || IsNil(o.Integrations) {
		return nil, false
	}
	return o.Integrations, true
}

// HasIntegrations returns a boolean if a field has been set.
func (o *CxTemplate) HasIntegrations() bool {
	if o != nil && !IsNil(o.Integrations) {
		return true
	}

	return false
}

// SetIntegrations gets a reference to the given CxTemplateIntegrations and assigns it to the Integrations field.
func (o *CxTemplate) SetIntegrations(v CxTemplateIntegrations) {
	o.Integrations = &v
}

// GetRequiredMessengers returns the RequiredMessengers field value if set, zero value otherwise.
func (o *CxTemplate) GetRequiredMessengers() []string {
	if o == nil || IsNil(o.RequiredMessengers) {
		var ret []string
		return ret
	}
	return o.RequiredMessengers
}

// GetRequiredMessengersOk returns a tuple with the RequiredMessengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetRequiredMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.RequiredMessengers) {
		return nil, false
	}
	return o.RequiredMessengers, true
}

// HasRequiredMessengers returns a boolean if a field has been set.
func (o *CxTemplate) HasRequiredMessengers() bool {
	if o != nil && !IsNil(o.RequiredMessengers) {
		return true
	}

	return false
}

// SetRequiredMessengers gets a reference to the given []string and assigns it to the RequiredMessengers field.
func (o *CxTemplate) SetRequiredMessengers(v []string) {
	o.RequiredMessengers = v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *CxTemplate) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *CxTemplate) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *CxTemplate) SetTags(v []string) {
	o.Tags = v
}

// GetInteractions returns the Interactions field value if set, zero value otherwise.
func (o *CxTemplate) GetInteractions() []CxTemplateInteractionsInner {
	if o == nil || IsNil(o.Interactions) {
		var ret []CxTemplateInteractionsInner
		return ret
	}
	return o.Interactions
}

// GetInteractionsOk returns a tuple with the Interactions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetInteractionsOk() ([]CxTemplateInteractionsInner, bool) {
	if o == nil || IsNil(o.Interactions) {
		return nil, false
	}
	return o.Interactions, true
}

// HasInteractions returns a boolean if a field has been set.
func (o *CxTemplate) HasInteractions() bool {
	if o != nil && !IsNil(o.Interactions) {
		return true
	}

	return false
}

// SetInteractions gets a reference to the given []CxTemplateInteractionsInner and assigns it to the Interactions field.
func (o *CxTemplate) SetInteractions(v []CxTemplateInteractionsInner) {
	o.Interactions = v
}

// GetGlobal returns the Global field value if set, zero value otherwise.
func (o *CxTemplate) GetGlobal() bool {
	if o == nil || IsNil(o.Global) {
		var ret bool
		return ret
	}
	return *o.Global
}

// GetGlobalOk returns a tuple with the Global field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetGlobalOk() (*bool, bool) {
	if o == nil || IsNil(o.Global) {
		return nil, false
	}
	return o.Global, true
}

// HasGlobal returns a boolean if a field has been set.
func (o *CxTemplate) HasGlobal() bool {
	if o != nil && !IsNil(o.Global) {
		return true
	}

	return false
}

// SetGlobal gets a reference to the given bool and assigns it to the Global field.
func (o *CxTemplate) SetGlobal(v bool) {
	o.Global = &v
}

// GetFormality returns the Formality field value if set, zero value otherwise.
func (o *CxTemplate) GetFormality() string {
	if o == nil || IsNil(o.Formality) {
		var ret string
		return ret
	}
	return *o.Formality
}

// GetFormalityOk returns a tuple with the Formality field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetFormalityOk() (*string, bool) {
	if o == nil || IsNil(o.Formality) {
		return nil, false
	}
	return o.Formality, true
}

// HasFormality returns a boolean if a field has been set.
func (o *CxTemplate) HasFormality() bool {
	if o != nil && !IsNil(o.Formality) {
		return true
	}

	return false
}

// SetFormality gets a reference to the given string and assigns it to the Formality field.
func (o *CxTemplate) SetFormality(v string) {
	o.Formality = &v
}

// GetPreviewUrls returns the PreviewUrls field value if set, zero value otherwise.
func (o *CxTemplate) GetPreviewUrls() []CxTemplatePreviewUrlsInner {
	if o == nil || IsNil(o.PreviewUrls) {
		var ret []CxTemplatePreviewUrlsInner
		return ret
	}
	return o.PreviewUrls
}

// GetPreviewUrlsOk returns a tuple with the PreviewUrls field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetPreviewUrlsOk() ([]CxTemplatePreviewUrlsInner, bool) {
	if o == nil || IsNil(o.PreviewUrls) {
		return nil, false
	}
	return o.PreviewUrls, true
}

// HasPreviewUrls returns a boolean if a field has been set.
func (o *CxTemplate) HasPreviewUrls() bool {
	if o != nil && !IsNil(o.PreviewUrls) {
		return true
	}

	return false
}

// SetPreviewUrls gets a reference to the given []CxTemplatePreviewUrlsInner and assigns it to the PreviewUrls field.
func (o *CxTemplate) SetPreviewUrls(v []CxTemplatePreviewUrlsInner) {
	o.PreviewUrls = v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *CxTemplate) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *CxTemplate) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *CxTemplate) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CxTemplate) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CxTemplate) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CxTemplate) SetId(v string) {
	o.Id = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *CxTemplate) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *CxTemplate) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given time.Time and assigns it to the CreatedAt field.
func (o *CxTemplate) SetCreatedAt(v time.Time) {
	o.CreatedAt = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *CxTemplate) GetUpdatedAt() time.Time {
	if o == nil || IsNil(o.UpdatedAt) {
		var ret time.Time
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UpdatedAt) {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *CxTemplate) HasUpdatedAt() bool {
	if o != nil && !IsNil(o.UpdatedAt) {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given time.Time and assigns it to the UpdatedAt field.
func (o *CxTemplate) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *CxTemplate) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplate) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *CxTemplate) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *CxTemplate) SetStatus(v string) {
	o.Status = &v
}

func (o CxTemplate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.HeaderImageUrls) {
		toSerialize["header_image_urls"] = o.HeaderImageUrls
	}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.Integrations) {
		toSerialize["integrations"] = o.Integrations
	}
	if !IsNil(o.RequiredMessengers) {
		toSerialize["required_messengers"] = o.RequiredMessengers
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	if !IsNil(o.Interactions) {
		toSerialize["interactions"] = o.Interactions
	}
	if !IsNil(o.Global) {
		toSerialize["global"] = o.Global
	}
	if !IsNil(o.Formality) {
		toSerialize["formality"] = o.Formality
	}
	if !IsNil(o.PreviewUrls) {
		toSerialize["preview_urls"] = o.PreviewUrls
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.UpdatedAt) {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	return toSerialize, nil
}

type NullableCxTemplate struct {
	value *CxTemplate
	isSet bool
}

func (v NullableCxTemplate) Get() *CxTemplate {
	return v.value
}

func (v *NullableCxTemplate) Set(val *CxTemplate) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplate(val *CxTemplate) *NullableCxTemplate {
	return &NullableCxTemplate{value: val, isSet: true}
}

func (v NullableCxTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


